<template>
    <!-- Type of message (Text | Image | Video | ... ) -->
    <div class="chatbox-contain row" :class="isSender ? 'justify-end' : ''">
        <div
            v-if="![MessageType.SYSTEM].includes(parseInt(`${message.type}`))"
            class="items-center q-ma-sm q-pa-sm"
            :class="
                isSender ? 'justify-end  chatbox-item-user' : 'chatbox-item'
            "
        >
            <div
                v-if="!isSender || searchResult"
                class="agent-name"
                @click="redirect(agentId)"
            >
                {{ agentName }}
            </div>
            <!-- Reply -->
            <bubble-reply
                class="justify-end row"
                v-if="message.repliedMessage"
                :message="message"
                :repliedMessage="message.repliedMessage"
            />
            <!-- Text -->
            <bubble-text
                v-if="
                    ![
                        MessageType.VIDEO,
                        MessageType.IMAGE,
                        MessageType.STICKER,
                        MessageType.EVENT_REMINDER,
                        MessageType.DOCUMENT,
                        MessageType.AUDIO,
                        MessageType.SYSTEM
                    ].includes(parseInt(`${message.type}`))
                "
                :message="message"
                :loading="loading"
            />

            <!-- Image -->
            <bubble-image
                v-if="message.type == MessageType.IMAGE"
                :message="message"
            />

            <!-- Video -->
            <bubble-video
                v-if="message.type == MessageType.VIDEO"
                :message="message"
            />

            <!-- Document -->
            <bubble-document
                v-if="message.type == MessageType.DOCUMENT"
                :message="message"
            />

            <!-- Audio -->
            <bubble-audio
                v-if="message.type == MessageType.AUDIO"
                :message="message"
            />

            <q-btn
                class="message-option"
                icon="mdi-chevron-down"
                size="8px"
                round
                unelevated
                :class="[isSender ? 'sender' : '']"
            >
                <message-context-menu :message="message" />
            </q-btn>
        </div>
    </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import { MessageType } from 'src/services/enums/MessageType';
import { Message } from 'src/services/models/Message';
import { Conversation } from 'src/services/models/Conversation';
import BubbleText from '../../components/chats/BubbleText.vue';
import BubbleImage from '../../components/chats/BubbleImage.vue';
import BubbleVideo from '../../components/chats/BubbleVideo.vue';
import BubbleDocument from '../../components/chats/BubbleDocument.vue';
import BubbleAudio from '../../components/chats/BubbleAudio.vue';
import BubbleReply from '../../components/chats/BubbleReply.vue';
import MessageContextMenu from '../../components/chats/MessageContextMenu.vue';
import MessageController from '../../controller/MessageController';
import { useRouter } from 'vue-router';
import { useStore } from 'src/store';

export default defineComponent({
    name: 'MessageBubble',
    components: {
        BubbleText,
        BubbleImage,
        BubbleVideo,
        BubbleDocument,
        BubbleAudio,
        MessageContextMenu,
        BubbleReply
    },
    props: {
        message: {
            type: Object as () => Message,
            required: true
        },
        conversation: {
            type: Object as () => Conversation
        },
        showName: {
            type: Boolean,
            default: false
        },
        loading: {
            type: Boolean
        },
        searchResult: {
            type: Boolean,
            default: false
        }
    },
    setup(props) {
        const router = useRouter();
        const store = useStore();

        const { isSender, agentName, agentId } = MessageController(
            props.message,
            true
        );

        const redirect = (id: string) => {
            router.push('/user/' + id);
            store.dispatch('menu/setSelectedShortcut', 'clients');
            store.dispatch('menu/setNoteDrawer', false);
        };

        return { MessageType, isSender, agentName, redirect, agentId };
    }
});
</script>
